<?php
namespace Planejamento\Entities;

use Geral\Util\NovoCodigo;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;

class Embdistcard extends Base\Embdistcard
{
    /** ok  ?*/
    public static function Insere($nrdistcard, $cdcontainer, $qtcontainer, $agrupemb,
                                  $dsobsetiqueta, $idcadauto, $connection, $docommit = true){
        try{
            if(!$connection){
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();
            }
            $nrorg = Ambiente::getNrorg();
            $cdoperador = Ambiente::getCdOperador();

            $nrembdistcard = NovoCodigo::geraCodigo($nrorg, 'EMBDISTCARD');
            $emb = new Embdistcard();

            $emb->setNrdistcard($nrdistcard);
            $emb->setNrembdistcard($nrembdistcard);
            $emb->setCdcontainer($cdcontainer);
            $emb->setQtcontainer($qtcontainer);
            $emb->setAgrupemb($agrupemb);
            $emb->setDsobsetiqueta($dsobsetiqueta);
            $emb->setIdcadauto($idcadauto);

            //Auditoria
            $emb->setNrorg($nrorg);
            $emb->setNrorginclusao($nrorg);
            $emb->setNrorgultatu($nrorg);

            $emb->setCdoperinclusao($cdoperador);
            $emb->setCdoperultatu($cdoperador);

            $emb->setDtinclusao(DateUtil::getDataAtual());
            $emb->setDtultatu(DateUtil::getDataAtual());

            $emb->setIdativo('S');
            $emb->persist();



            $connection->flush();
            if($docommit) $connection->commit();

            return $emb->getNrembdistcard();
        }catch(\Exception $e){
            if($docommit) $connection->rollback();
            throw $e;
        }

    }

    public static function Atualiza($nrembdistcard, $qtcontainer, $dsobsetiqueta, $idcadauto, $idativo,
                                    $connection, $docommit = true){
        try{
            if(!$connection){
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();
            }

            $nrorg = Ambiente::getNrorg();
            $cdoperador = Ambiente::getCdOperador();

            $emb = Embdistcard::getObjectByWhere('NRORG = ? AND NREMBDISTCARD = ?',
                                                 array($nrorg, $nrembdistcard));

            if($emb) {
                $emb->setQtcontainer($qtcontainer);
                $emb->setDsobsetiqueta($dsobsetiqueta);
                $emb->setIdcadauto($idcadauto);

                //Auditoria
                $emb->setNrorgultatu($nrorg);

                $emb->setCdoperultatu($cdoperador);

                $emb->setDtultatu(DateUtil::getDataAtual());

                $emb->setIdativo($idativo);
                $emb->persist();
            }
            $connection->flush();
            if($docommit) $connection->commit();
        }catch(\Exception $e){
            if($docommit) $connection->rollback();
            throw $e;
        }
    }

    public static function Apaga($nrembdistcard, $connection, $docommit = true){
        try{
            if(!$connection){
                $connection = \Setforms2\Shared\Registry::getEntityManager();
                $connection->beginTransaction();
            }
            $nrorg = Ambiente::getNrorg();

            $emb = Embdistcard::getObjectByWhere('NRORG = ? AND NREMBDISTCARD = ?',
                                                 array($nrorg, $nrembdistcard));
            if($emb){
                $emb->delete();
            }

            $connection->flush();
            if($docommit) $connection->commit();
        }catch(\Exception $e){
            if($docommit) $connection->rollback();
            throw $e;
        }
    }


}